#!/usr/bin/perl

# **
# * ------------------------------------------------------------------------
# * BlueMind Stats Portal, aka bm-stats
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
# * ------------------------------------------------------------------------
# **

BEGIN {
    push @INC,"/usr/share/bm-stats/scripts/PERL/";
};

require "bmFunctions.pl";

#use strict;
use List::Util qw(sum);
use Date::Calc qw(Week_Number Mktime);
use Encode ;
use File::Path ;
use File::Copy ;
use Data::Dumper qw(Dumper) ;

######################################
#
# Var settings
#
######################################




my $limit = 5; #only the last $limit (minutes) lines are parsed 

# Liste des minutes a  prendre en compte
my ($dbt,$liste_dbt, $date) = &coreTimeLimit($limit);

my $path_to_data_dir = "/var/lib/bm-stats/" ;



# init launch mktime 
my $mktime = time() ;

# the current core log file
my $file     = "core.log" ;
my $path_to_log_file = "/var/log/bm/";
my $logFile     = $path_to_log_file.$file ;


my $thisAccount      = "" ;
my $thisDomain       = "" ;
my $thisMasterDomain = "" ;


my @history     = () ;
my @historyKey  = () ;
my @historyKeyN = () ;


my %history      = () ;
my %log          = () ;
my %masterDomain = () ;

our %compteur    = ();


#
###################################################################

##################################################################
#
# Local functions
#
##################################################################

sub parseThisFile {
    
    $log_file = $_[0];
    
    # A quel endroit se positionner directement dans le fichier
    my $start_pos=`grep -m 1 -b "$dbt" $log_file | cut -d : -f1`;
    
    open(F, $log_file) || die "Error while opening : $!";
    seek F, $start_pos,0 ;

    while(<F>) {
        $thisAccount  = "" ;

        if($_ =~ m%^($liste_dbt)%) {
            #print "$_ \n";
        } else {
            next;
        };
	#2017-03-20 15:50:54,151 [BM-Core8] n.b.a.s.Authentication ERROR - authContext.user is null for login: alber.einstein@bm35-debian8.intra origin: bm-hps remoteIps: [127.0.1.1, 127.0.0.1, 192.168.122.5]
        #                                                                                      1              2
        if($_ =~ m%.*authContext.user is null for login: (.*) origin: .*% ) {
            
            $thisAccount = $1 ;
	    my @prefixe = split(/\@/,$thisAccount);
            $thisDomain = $prefixe[1];
                $thisMasterDomain = $masterDomain{$thisDomain};

            push @{$compteur{$thisMasterDomain}}, 1 ;
            push @{$compteur{'Global'}}, 1 ;
        };
    };

    close(F) ;
}


#
###################################################################


#######################################
#
# Job starting HERE
#
#######################################


my $res = `/usr/bin/php5 /usr/share/bm-stats/scripts/PHP/api/listAllDomain.php` ;
   $res =~ s/\n// ;

%masterDomain = split (/ /,$res) ;
$masterDomain{'global.virt'} = 'global.virt' ;
$masterDomain{'Global'} = 'Global' ;


foreach $thisMasterDomain (values %masterDomain) {
    
    push (@{$compteur{$thisMasterDomain}},0) ;   
    
} 

$nbDomain = keys %compteur ;



#
# LogFile Parse
#

# Parse du fichier "regulier"
&parseThisFile($logFile) ;

#
## Fin du Parse 
#

#print Dumper(\\ %compteur); 

#
## Alimentation du fichier d'alimentation du lastCyrusConnexion.dat
#

my $dir = $path_to_data_dir."general/" ;
my $thisRealTimeFile = $dir."realTimeCore.dat" ;

@historyKey = () ;
%history = () ;
%history = &readRealTimeFile($thisRealTimeFile);


foreach my $domain (keys(%compteur)) {
	
	my $nbt  = sum( @{$compteur{$domain}} );  # nb of messages filled 

	$history{$mktime."-".$domain} = "$domain,$nbt";
   
};





@historyKey = sort (keys %history) ;
$nbElement  = @historyKey ;
$maxElement = $nbDomain*288; # 288 = 12 parse/hour * 24 hours    

if ( $nbElement> $maxElement) {
    @historyKeyN = @historyKey[-$maxElement..-1];
} else {
    @historyKeyN = @historyKey ;
};


# Erase the file
if(-f  $thisRealTimeFile) {
    open(FrealTime,"> $thisRealTimeFile") || die "Error while opening : $!";
    close(FrealTime);
};

    
# Feed the file
open(FrealTime,">> $thisRealTimeFile") || die "Error while opening : $!";
foreach my $key (@historyKeyN) { 
    my $thisLine = $key.";".$history{$key}."\n";
    print FrealTime $thisLine ;

};
    
close(FrealTime);
    
    
my $trash = `/usr/bin/php5 /usr/share/bm-stats/scripts/PHP/do_graph/bmLastCoreH24.php`;

