<?php
/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/

/* A free litle class published with bmStats */
require_once('/usr/share/bm-stats/www/class/bmAPI/bmAPI.php');

/* The account we used  */
$login = "admin0@global.virt";
$password  = file("/etc/bm/bm-core.tok")[0];

/* All we need to write the URI */
$bmIni = '/etc/bm/bm.ini';
$dataBmIni = parse_ini_file($bmIni);
$baseUrl=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/api/";


/* A set of options used by the cURL client  */
$option = array(
                        CURLOPT_VERBOSE        => FALSE,
                        CURLOPT_RETURNTRANSFER => TRUE,
                        CURLOPT_SSL_VERIFYPEER => FALSE,
                        CURLOPT_SSL_VERIFYHOST => 0,
                        CURLOPT_CONNECTTIMEOUT => 5,
                        CURLOPT_TIMEOUT        => 5,
                      );

/* Get a token for next operations */

// Define the URI
$uri=$baseUrl."auth/login?login=$login&origin=bmStat";

$api = new bmAPI();
$api->init() ;
$api->setOption($option);
$api->setURI($uri);
$api->post($password,false); //the 2nd param is set to  "false" because $password is not json encoded, otherwise set it to "true"
$api->setPhpResponse() ;
$token = $api->getResponse()['authKey'];
$api->close() ; //Please close it.


// Define the URI
$uri=$baseUrl."domains";
$api->init() ;
$api->setOption($option);
$api->setURI($uri);
$api->setPhpResponse() ;
$api->setHeaderKey($token); //Here we set the token we've got above in the request Header
$res = $api->getResponse() ;
$api->close() ;


$thisList = [] ;
foreach ($res as $domain) {

        if ($domain['uid'] != "global.virt") { 
                $thisList[] = $domain['uid']." ".$domain['uid'] ;
                if (!empty($domain['value']['aliases']))
                        foreach ($domain['value']['aliases'] as $alias)
                                $thisList[] = $alias." ".$domain['uid'];
        }

}

print implode(" ", array_unique($thisList)) ;


?>
