<?php
/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 
/* Variables modifiables*/
$path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;


require("/usr/share/bm-stats/www/conf/config.php");
require("/usr/share/bm-stats/www/function/dir_file.php");
require("/usr/share/bm-stats/www/function/lang.php");
require("/usr/share/bm-stats/www/function/date.php");


function get_H24Values() {

    Global $path_to_data ;

    $thisArray = array() ;
    $this_file = $path_to_data."/general/realTimeCore.dat" ;


    $val = file($this_file) ;
    sort($val) ;
    
    // 1399719301-global.virt;Global,0
    // 1399719301-mclabosse.fr;mclabosse.fr,0


    foreach($val as $line) {
        
        $line= trim($line) ;
        $values = explode(";",$line);
        $key = explode('-',$values[0]) ;

        $mktime       = $key[0];
            $hour = date("H",$mktime) ;
            $min  = date("i",$mktime) ;

        $subValues     = explode(",",$values[1]) ;    
            $domain    = $subValues[0] ;
            $nb        = $subValues[1] ;



        $thisArray[$domain]['x'][$mktime] = "";
        if($min == '00') {
            $thisArray[$domain]['x'][$mktime] = "$hour:00" ;
        };

        $thisArray[$domain]['y'][$mktime] = $nb ; 
       
    };    

    return $thisArray ;

} ;



function graphH24Values() {

    Global $path_to_data, $path_to_pChart ;


    $thisHour = date("H:i") ;

    if(date("z") == "0" ) { 
        $this_year = date("Y") - 1 ; 
    } else { 
         $this_year = date("Y"); 
    };


    $mktime_yesterday = mktime(0,0,0,date("m"),date("d")-1,date("y"));
    $this_year  = date("Y",$mktime_yesterday);
    $this_month = date("m",$mktime_yesterday);
    $this_n_day   = date("z",$mktime_yesterday);




    $thisValues = get_H24Values() ;

    /* pChart library inclusions */
    require_once $path_to_pChart."class/pData.class.php";
    require_once $path_to_pChart."class/pDraw.class.php";
    require_once $path_to_pChart."class/pImage.class.php";

    foreach (array_keys($thisValues) as $domain) {

        if( ! in_array($domain, array('Global','global.virt')))  {
            
            $myLang = getLang($domain) ;
            if(!empty($myLang)) $lang=$myLang ;

            require("/usr/share/bm-stats/www/inc_lang/inc_lang_$lang.php");

            $this_lit_month = get_month($this_month); 
            $this_full_day = date("d",$mktime_yesterday)." ".$this_lit_month." ".$this_year;


            /* Liste des titres dans les graphes */
            $title  = $l_H24Core_title;
        
            if( $thisHour == "00:00" ) 
                    $title  = $l_H24Core_titled." $this_full_day";


            $MyData = new pData();

            $path_to_img = $path_to_data.$domain."/img/";
            $img = $path_to_img."surveyLog.png" ; 
            
            // Ctrl existance du dossier image
            verif_existence_rep($path_to_img);
                        
            $x  =  $thisValues['Global']['x'] ;


            $y1_title = "Domaine $domain";
            $y1       = $thisValues[$domain]['y'] ;
            $MyData->addPoints($y1,$y1_title);
            $y1_colorscheme = array("R"=>15,"G"=>44,"B"=>52,"Alpha"=>100);
            $MyData->setPalette($y1_title,$y1_colorscheme);


            $y2_title = "Global Serveur";
            $y2       = $thisValues['Global']['y'];
            $MyData->addPoints($y2,$y2_title);
            $y2_colorscheme = array("R"=>184,"G"=>0,"B"=>40,"Alpha"=>40);
            $MyData->setPalette($y2_title,$y2_colorscheme);



            $MyData->addPoints($x,"Labels");
            $MyData->setSerieDescription("Labels","Month");
            $MyData->setAbscissa("Labels");

            /* Create the pChart object */
            $myPicture = new pImage(1200,300,$MyData);
            
            $myPicture->drawGradientArea(0,0,1200,300,DIRECTION_VERTICAL,array("StartR"=>166,"StartG"=>202,"StartB"=>219,"EndR"=>17,"EndG"=>90,"EndB"=>134,"Alpha"=>100));   
            //$myPicture->drawGradientArea(0,250,1200,300,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));

            $myPicture->drawLine(0,249,1200,249,array("R"=>0,"G"=>0,"B"=>0));
            $myPicture->drawLine(0,250,1200,250,array("R"=>70,"G"=>70,"B"=>70));
            
            /* Add a border to the picture */
            $myPicture->drawRectangle(0,0,1199,299,array("R"=>204,"G"=>204,"B"=>204));

            /* Write the picture title */
            $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/DejaVuSansMono-Bold.ttf","FontSize"=>10));
            $myPicture->drawText(500,14,$title,array("R"=>47,"G"=>47,"B"=>47,"Align"=>TEXT_ALIGN_MIDDLEMIDDLE));

            $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));

            /* Define the chart area */
            $myPicture->setGraphArea(58,27,1180,228);
            
            /* Draw a rectangle */
            $myPicture->drawFilledRectangle(58,27,1180,228,array("R"=>180,"G"=>180,"B"=>180,"Dash"=>TRUE,"DashR"=>250,"DashG"=>250,"DashB"=>250,"BorderR"=>150,"BorderG"=>150,"BorderB"=>150));
                            
            /* Turn on shadow computing */
            $myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>20));
                                             
            /* Draw the scale */
            $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
            $ScaleSettings = array("DrawArrows"=>TRUE,"ArrowSize"=>4,"DrawXLines"=>FALSE,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);
            $myPicture->drawScale($ScaleSettings);

            /* Draw the spline chart */
            $myPicture->drawSplineChart();


            /* Write the chart boundaries */
            //$BoundsSettings = array("MaxDisplayR"=>237,"MaxDisplayG"=>23,"MaxDisplayB"=>48,"MinDisplayR"=>23,"MinDisplayG"=>144,"MinDisplayB"=>237);
            //$myPicture->writeBounds(BOUND_BOTH,$BoundsSettings);


            /* Write the chart legend */
            $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
            $myPicture->drawLegend(650,258,array("Style"=>LEGEND_NOBORDER));

            //number_format(, 2, '.', '')

            /* Write the 1st data series statistics */
            $Settings = array("R"=>15,"G"=>44,"B"=>52,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
            $myPicture->drawText(820,265,"Max : ".number_format(ceil($MyData->getMax($y1_title)), 0, '.', ' '),$Settings);
            $myPicture->drawText(900,265,"Min : ".number_format(ceil($MyData->getMin($y1_title)), 0, '.', ' '),$Settings);
            $myPicture->drawText(980,267,"Avg : ".number_format(ceil($MyData->getSerieAverage($y1_title)), 0, '.', ' '),$Settings);
            $myPicture->drawText(1060,265,"Tot : ".number_format(ceil(array_sum($y1)), 0, '.', ' '),$Settings);



            /* Write the 2nd data series statistics */
            $Settings = array("R"=>184,"G"=>0,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
            $myPicture->drawText(820,278,"Max : ".number_format(ceil($MyData->getMax($y2_title)), 0, '.', ' '),$Settings);
            $myPicture->drawText(900,278,"Min : ".number_format(ceil($MyData->getMin($y2_title)), 0, '.', ' '),$Settings);
            $myPicture->drawText(980,280,"Avg : ".number_format(ceil($MyData->getSerieAverage($y2_title)), 0, '.', ' '),$Settings);
            $myPicture->drawText(1060,278,"Tot : ".number_format(ceil(array_sum($y2)), 0, '.', ' '),$Settings);


            $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
            $myPicture->drawText(1050,295,"[ ".date("d/m/Y H:i:s")." ] ",array("R"=>255,"G"=>255,"B"=>255));
            $myPicture->drawFromPNG(5,249,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");

            /* Render the picture (choose the best way) */
            $myPicture->render($img);

            if( $thisHour == "00:00" ) {
                $imgBackup = $path_to_data.$domain."/img/".$this_year."/D".$this_n_day."_surveyLog.png" ;
                copy($img, $imgBackup);
            };
        };
    };   
};

graphH24Values() ;

?>
