<?php
/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 
/*
On suppose que le rapport est fait le 1er de chaque mois
*/


function get_bm_figure() {

	/* A free litle class published with bmStats */
	require_once('/usr/share/bm-stats/www/class/bmAPI/bmAPI.php');

	/* The account we used  */
	$login = "admin0@global.virt";
	$password  = file("/etc/bm/bm-core.tok")[0];

	/* All we need to write the URI */
	$bmIni = '/etc/bm/bm.ini';
	$dataBmIni = parse_ini_file($bmIni);
	$baseUrl=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/api/";


	/* A set of options used by the cURL client  */
	$option = array(
                        CURLOPT_VERBOSE        => FALSE,
                        CURLOPT_RETURNTRANSFER => TRUE,
                        CURLOPT_SSL_VERIFYPEER => FALSE,
                        CURLOPT_SSL_VERIFYHOST => 0,
                        CURLOPT_CONNECTTIMEOUT => 5,
                        CURLOPT_TIMEOUT        => 5,
                      );

	/* Get a token for next operations */

	// Define the URI
	$uri=$baseUrl."auth/login?login=$login&origin=bmStat";

	$api = new bmAPI();
	$api->init() ;
	$api->setOption($option);
	$api->setURI($uri);
	$api->post($password,false); //the 2nd param is set to  "false" because $password is not json encoded, otherwise set it to "true"
	$api->setPhpResponse() ;
	$token = $api->getResponse()['authKey'];
	$api->close() ; //Please close it.


	$thisList = array() ;
	$this_array = array() ;
        $tmp = array() ;
	$thisEnabled = "" ;


	// Define the URI
	$uri=$baseUrl."domains";
	$api->init() ;
	$api->setOption($option);
	$api->setURI($uri);
	$api->setPhpResponse() ;
	$api->setHeaderKey($token); //Here we set the token we've got above in the request Header
	$allDomains = $api->getResponse() ;
	$api->close() ;


	$excludeUser = array("bmhiddensysadmin","_user","_admin") ;

	foreach ($allDomains as $domain) {
	
	        if ($domain['uid'] != "global.virt") {
                
                        $thisDomain = $domain['uid'] ;
                        $this_array[$thisDomain]['mbox']              += 0 ;
                        $this_array[$thisDomain]['archive']['count']  += 0 ;
                        $this_array[$thisDomain]['archive']['address'] = array() ; 
                        $this_array[$thisDomain]['redirected_mbox']   += 0 ;
                        $this_array[$thisDomain]['aliases']            =  $domain['aliases']; 
                        
                        /* Get all accounts (not only mbox)*/
                        $uri=$baseUrl."users/".$domain['uid']."/_alluids";
                        $api->init() ;
                        $api->setOption($option);
                        $api->setURI($uri);
                        $api->setPhpResponse() ;
                        $api->setHeaderKey($token); //Here we set the token we've got above in the request Header
                        $allDomainAccounts = $api->getResponse() ;
                        $api->close() ;
                        
                        $this_array[$thisDomain]['account'] = count($allDomainAccounts) - 1 ; // -1 because "bmhiddensysadmin"
                        
                        
                        
                        
                        /* Get all mailboxes of this domain */
                        $uri=$baseUrl."mailboxes/".$domain['uid']."/_list";
                        $api->init() ;
                        $api->setOption($option);
                        $api->setURI($uri);
                        $api->setPhpResponse() ;
                        $api->setHeaderKey($token); //Here we set the token we've got above in the request Header
                        $allDomainMBoxes = $api->getResponse() ;
                        $api->close() ;
                        
                        
                        foreach ($allDomainMBoxes as $account) {
                        
                                $thisName   = $account['value']['name'] ;
                        
                                if(!in_array($thisName,$excludeUser)) {
                                
                                        $thisUid = $account['uid'];
                                        $this_array[$thisDomain]['mbox']++;
                                       
 
                                        if ($account['value']['archived']) {
                                                $this_array[$thisDomain]['archive']['count'] ++ ;
                                                $this_array[$thisDomain]['archive']['address'][] = $thisName ;
                                        };
                                        
                                        /* Get this mailbox quota values */
                                        $uri=$baseUrl."mailboxes/".$domain['uid']."/$thisUid/_quota";
                                        $api->init() ;
                                        $api->setOption($option);
                                        $api->setURI($uri);
                                        $api->setPhpResponse() ;
                                        $api->setHeaderKey($token); //Here we set the token we've got above in the request Header
                                        $itsQuotaValues = $api->getResponse() ;
                                        $api->close() ;
                                
                                        if (!empty($itsQuotaValues['quota'])) {
                                                $this_array[$thisDomain]['quota'][] = $itsQuotaValues['quota'] * 1024 ;
                                                $this_array[$thisDomain]['quota_use'][] = $itsQuotaValues['used'] * 1024 ;
                                        
                                        } else {
                                                $this_array[$thisDomain]['quota_unlim']++;
                                        
                                        };
                                }
                        }
                }
        }
        
        if(!empty($this_array)) {
		foreach (array_keys($this_array) as $thisDomain) {
		
			$thisData = $this_array[$thisDomain] ;

			if(!empty($thisData['quota']) && is_array($thisData['quota'])) {
			        sort($thisData['quota']) ;
												
				$this_array[$thisDomain]['max_mbox_quota']  = print_in_KMGT_octet(max($thisData['quota']));
				$this_array[$thisDomain]['min_mbox_quota']  = print_in_KMGT_octet(min($thisData['quota']));
				$this_array[$thisDomain]['ceil_quota']      = print_in_KMGT_octet(round((array_sum($thisData['quota'])/$thisData['mbox']),0)) ;
				$this_array[$thisDomain]['ceil_used_quota'] = print_in_KMGT_octet(round((array_sum($thisData['quota_use'])/$thisData['mbox']),0)) ;         
			}
		};
	};

        return $this_array ;

}


function get_percent($a,$b) {
	
	if($b == 0) { $b = 1 ;};	

	$c = ($b - $a)/$b ;
	$c = floor(10000*$c)/100;

	return $c ;
};


function verif_existence_rep($rep)
{
    $PATH=$rep;
    if(!(is_dir($PATH))) {
        $cmd = "mkdir -p $PATH ; chmod -R 755 $PATH  ; chown -R root.www-data $PATH";
        exec($cmd);
    } else {
        $cmd = "chmod -R 755 $PATH ; chown -R root.www-data $PATH ";
        exec($cmd);
    };

};


?>
