<?php

/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 

/*
Return list of userobm matching whith $string
Note : called only in listUserObm.php file

*/

function listeUserBm($string) {

    $thisListe = "" ;
    $thisPattern = "/".$string."/";

 
    $excludeUser = array("admin","bmhiddensysadmin","_user","_admin") ;
    require_once("/usr/share/bm-stats/www/class/bmAPI/bmAPI.php");

    $bmIni = '/etc/bm/bm.ini';
    $dataBmIni = parse_ini_file($bmIni);

    $baseUrl=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/api/" ;

    /* A set of options used by the cURL client  */
    $option = array(
                            CURLOPT_VERBOSE        => FALSE,
                            CURLOPT_RETURNTRANSFER => TRUE,
                            CURLOPT_SSL_VERIFYPEER => FALSE,
                            CURLOPT_SSL_VERIFYHOST => 0,
                            CURLOPT_CONNECTTIMEOUT => 5,
                            CURLOPT_TIMEOUT        => 5,
                          );

    // Define the URI
    $uri=$baseUrl."mailboxes/".$_SESSION['domainName']."/_list";

    $api = new bmAPI();
    $api->init() ;
    $api->setOption($option);
    $api->setURI($uri);
    $api->setHeaderKey($_SESSION['token']); //Here we set the token we've got above in the request Header
    $api->setPhpResponse(); 
    $allEntries = $api->getResponse() ;
    $api->close() ;

   
    foreach ($allEntries as $entry) {
      
        $thisUser   = $entry['value']['name'] ;
       
        if(!in_array($thisUser,$excludeUser)) {  
            if(preg_match($thisPattern, $thisUser)) {  
                $thisListe.="<li onClick=\"fill('$thisUser');\" > $thisUser </li>\n";
            };
        };
    };


    return $thisListe ;

}

/*
Return html code 
*/
function user_stat_form() {
    
    Global $l_userstat_account,$l_userstat_valid;
    $form = "
    <div id='ombreeH12'>
    <h1 id='h12'>
    <form method='post' action='#' name='frm' id='form1'>
            
                <div style='position: relative; border : 0px solid black; width: 500px; color: #338195; background-color: #a2cdda; padding: 1px ;'>
                    <div style='position: absolute; top: 0; width: 140px; border : 0px solid black ; padding: 2px ; font-weight: bold; size :100% ;'>
                        $l_userstat_account :
                    </div>
                    <input type=\"text\" style='width:250px;margin-left : 154px;'  name='userbm' value=\"\" id=\"inputString\" onkeyup=\"lookup(this.value);\" onblur=\"fill();\" />
                    <div class=\"suggestionsBox\" id=\"suggestions\" style=\"display: none;\">
                        <img src=\"./images/upArrow.png\" style=\"position: relative; top: -12px; left: 10px;\" alt=\"upArrow\" />
                        <div class=\"suggestionList\" id=\"autoSuggestionsList\">
                            &nbsp;
                        </div>
                
                    </div>
                    <div style='position: absolute; top: 0; right: 0; width: 90px'>
                        <input type='hidden' name='action' value='userstat'>
                        <input type='hidden' name='item' value='User'>
                        <div id='loading1' style='display:none;'>&nbsp;&nbsp;&nbsp;<img src='./images/loader.gif' alt='' /></div>
                        <input id='submit1' type='submit' value='$l_userstat_valid' >
                    </div>
                </div>    
    </form>
    <script type='text/javascript'>
        (function (d) {
            d.getElementById('form1').onsubmit = function () {
                d.getElementById('submit1').style.display = 'none';
                d.getElementById('loading1').style.display = 'block';
            };
        }(document));
    </script>



    </h1>
    </div>
    ";

    return $form ;

};


/*
array get_figures_from_user(string($this_user), int ($oneYear) )
Retourne un tableau php contenant les valeurs pour l'utilisateur "$this_user"
$oneYear : 0/1 , limite la sortie a 365 jours (si pas de date fournie)
Ces valeurs correspondent :
- aux nb de messages envoyes
- aux volumes (en octets) envoyés
- aux nb de messages recus
- aux volumes (en octets) recus
*/

function get_figures_from_user($bmUser,$oneYear) {

    Global $path_to_data ; 

    $thisArray = array(); 

    $this_user_file = $path_to_data.$_SESSION['domainName']."/user/".$bmUser ;


    if(file_exists($this_user_file)) {

        $ligne = file($this_user_file);        
  
        $nbEntry = count($ligne) ;
        if( $nbEntry > 31 ) {
            //Get only 31 values if no date set ($oneYear == "0")
            if($oneYear == "1") {
                $thisArray = array_slice($ligne,-31,31,true);
            } else {
                $thisArray = $ligne;
            };
        } else {
            $thisArray = $ligne;
        };    

        foreach ($thisArray as $this_ligne) {
            $odt = 0 ; $odc = 0 ; $odp = 0 ; $doc = 0 ; $xls = 0 ; $ppt = 0 ; $txt = 0 ; $rtf = 0 ; $pdf = 0 ; $docx = 0 ; $xlsx = 0 ; $pptx = 0 ; 
            $jpeg = 0 ; $tiff = 0 ; $png = 0 ; $svg = 0 ; $bmp = 0 ; $gif = 0 ; 
            $avi = 0 ; $wma = 0 ; $swf = 0 ; $mp3 = 0 ; $mpeg = 0 ; $mov = 0 ; $vob = 0 ; 
            $zip = 0 ; $bz = 0 ; $gz = 0 ; $z7 = 0 ; $p7s = 0 ; $acidcsa = 0 ; $rar = 0 ;

            $var=explode(",",$this_ligne);
            $date = $var['0'];    
            $nbf  = $var['1'] + 0 ;
            $volf = round($var['2']/1000) + 0;
            $nbr  = $var['3'] + 0 ;
            $volr = round($var['4']/1000) + 0 ;
            $nbAtt0 = $var['5'] + 0 ;
            $nbAtt1 = $var['6'] + 0 ; 
            $nbAtt2 = $var['7'] + 0 ;
            $nbAtt3 = $var['8'] + 0 ;
            $nbAtt4 = $var['9'] + 0 ;
            $nbAtt5 = $var['10'] + 0 ;
            $nbAtt6 = $var['11'] + 0 ;

            $volAtt100 = $var['12'] + 0 ;
            $volAtt200 = $var['13'] + 0 ;
            $volAtt500 = $var['14'] + 0 ;
            $volAtt1M = $var['15'] + 0 ;
            $volAtt2M = $var['16'] + 0 ;
            $volAtt3M = $var['17'] + 0 ;
            $volAtt4M = $var['18'] + 0 ;
            $volAtt5M = $var['19'] + 0 ;
            $volAtt6M = $var['20'] + 0 ;

            $volmimetype = $var['21'];
            $byExt = explode(";",$volmimetype) ;
            foreach ($byExt as $val) {
                $value = 0 ;
                $part = explode(":", $val);
                $ext   = $part['0'];
                if(isset($part['1']))
                  $value = $part['1'];
                            

                //Office extension
                if($ext=="odt")  { $odt = $value  ; };
                if($ext=="odc")  { $odc = $value  ; };
                if($ext=="odp")  { $odp = $value  ; };
                if($ext=="doc")  { $doc = $value ; };    
                if($ext=="xls")  { $xls = $value  ; };
                if($ext=="ppt")  { $ppt = $value ; };
                if($ext=="txt")  { $txt = $value  ; };
                if($ext=="rtf")  { $rtf = $value  ; };
                if($ext=="pdf")  { $pdf = $value  ; };    
                if($ext=="docx") { $docx = $value + 0 ; };    
                
                if($ext=="xlsx") { $xlsx = $value  ; };
                if($ext=="pptx") { $pptx = $value  ; };     

                //Pictures extension
                if($ext=="jpeg") { $jpeg = $value ; };
                if($ext=="tiff") { $tiff = $value  ; };         
                if($ext=="png")  { $png = $value  ; };
                if($ext=="svg")  { $svg = $value ; };
                if($ext=="bmp")  { $bmp = $value  ; };
                if($ext=="gif")  { $gif = $value ; };

                //Multimedia extension
                if($ext=="avi")  { $avi = $value ; };
                if($ext=="wma")  { $wma = $value ; };         
                if($ext=="swf")  { $swf = $value ; };
                if($ext=="mp3")  { $mp3 = $value ; };
                if($ext=="mpeg") { $mpeg = $value ; };
                if($ext=="mov")  { $mov = $value ; };
                if($ext=="vob")  { $vob = $value ; };


                //Compress extension
                if($ext=="zip")     { $zip = $value ; };
                if($ext=="bz")      { $bz = $value ; };         
                if($ext=="gz")      { $gz = $value ; };
                if($ext=="7z")      { $z7 = $value ; };
                if($ext=="p7s")     { $p7s = $value ; };
                if($ext=="rar")     { $rar = $value ; };
                       
            };


            if(!empty($date)) {
                $thisNewArray[$date] = array($nbf,$volf,$nbr,$volr,$nbAtt0,$nbAtt1,$nbAtt2,$nbAtt3,$nbAtt4,$nbAtt5,$nbAtt6,$volAtt100,$volAtt200,$volAtt500,$volAtt1M,$volAtt2M,$volAtt3M,$volAtt4M,$volAtt5M,$volAtt6M,$odt,$odc,$odp,$doc,$xls,$ppt,$txt,$rtf,$pdf,$docx,$xlsx,$pptx,$jpeg,$tiff,$png,$svg,$bmp,$gif,$avi,$wma,$swf,$mp3,$mpeg,$mov,$vob,$zip,$bz,$gz,$z7,$p7s,$rar); 
            };
        };
    };
       
    return $thisNewArray ;

} ;


/*
array reduce_this_array(array(&$this_array),timestamp($mktime),string($sens))
Reduit le tableau à la plage demandee 
$this_array : tableau de cles (timestamp) pour un user
$mktime     : timestamp de reference
$sens       : A(nte), P(ost)

*/

function reduce_this_array(&$this_array,$mktime,$sens) {

    $this_new_array = array() ;
      
    foreach( $this_array as $key) {
        if ($sens == "A") {
            // Delete before
            if($key >= $mktime) {
                $this_new_array[] = $key ;
            };
        };
        if ($sens == "P") {
            // Delete after
            if($key <= $mktime) {
                $this_new_array[] = $key ;
            };
        } ;
    };
    
    return $this_new_array ;
};


/*
$timstamp : 
$setFull  :
*/

function SetXScaleDate($timestamp,$setFull) {
    $timestamp += 0 ;
    $jour = date("d",$timestamp);
    $mois = date("m",$timestamp);

    if($setFull == "1") {
        $xscaled = $jour." ".get_month($mois) ;
    } else {
           if($jour == "01") {
            $xscaled = $jour." ".get_month($mois) ;
        } else {    
            $xscaled = " " ;
        };
    };   
    return $xscaled ;
};

function delInTMP($this_user,$this_case) {

    $filename = $this_user."_".$this_case."_.png";
    $this_file = "./tmp/$filename" ;
    if(file_exists($this_file)) {
        unlink($this_file);
    };
}


function copyToTMP($this_user,$this_case) {

    Global $path_to_data ;
    
    $path_to_img = $path_to_data.$_SESSION['domainName']."/img_user/";
    $filename = $this_user."_".$this_case."_.png";

    $source      = $path_to_img.$filename ;
    $destination = "./tmp/$filename" ;
    
    $data = file_get_contents($source);
    $handle = fopen($destination, "w");
    fwrite($handle, $data);
    fclose($handle);

    //chmod ($destination, 0666) ;
};

/*
$this_case : N (Number of messages), V (Volume of messages)
*/

function user_general_graphe_this(&$this_figures,&$this_figures_KEY,$this_user,$this_case,$mkStart,$mkStop) {

    Global $l_block_graph_user_ingoing_title, $l_block_graph_user_outgoing_title, $l_block_graph_user_outgoingvol_title, $l_block_graph_user_ingoingvol_title;
    Global $l_block_graph_user_NB_title, $l_block_graph_user_VOL_title;     
    Global $l_block_graph_user_from, $l_block_graph_user_to, $l_block_graph_user_since, $l_block_graph_user_toEnd;   
    Global $path_to_data,$maxFullDateOnGraph ;

    $setFull = "0" ;
    
    $path_to_img = $path_to_data.$_SESSION['domainName']."/img_user/";
    verif_existence_rep($path_to_img);

    /* pChart library inclusions */
    $path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;
    require_once $path_to_pChart."class/pData.class.php";
    require_once $path_to_pChart."class/pDraw.class.php";
    require_once $path_to_pChart."class/pImage.class.php";
       

    $nbDate = count($this_figures_KEY);
    if($nbDate <= $maxFullDateOnGraph) {$setFull = "1"; };

        $y1_total = "0" ;
        $y2_total = "0" ;
        if($this_case == "N") {
        //$y1 : received
        //$y2 : sent  
        $img = $path_to_img.$this_user."_N_.png";

        $title = $l_block_graph_user_NB_title." ".$this_user ;
        $y1_title = $l_block_graph_user_ingoing_title ;
        $y2_title = $l_block_graph_user_outgoing_title;

        foreach ($this_figures_KEY as $thisKey) {
            $x[] = SetXScaleDate($thisKey,$setFull) ;       

            $y1[]  = $this_figures[$thisKey][2];
            $y1_total += $this_figures[$thisKey][2];

            $y2[]  = $this_figures[$thisKey][0];
            $y2_total += $this_figures[$thisKey][0];
        };

    };

    if($this_case == "V") {
        //$y1 : received
        //$y2 : sent  
        $img = $path_to_img.$this_user."_V_.png";
        $title = $l_block_graph_user_VOL_title." ".$this_user; 
        $y1_title = $l_block_graph_user_ingoingvol_title ;
        $y2_title = $l_block_graph_user_outgoingvol_title;

        foreach ($this_figures_KEY as $thisKey) {
            $x[] = SetXScaleDate($thisKey,$setFull) ;     
            $y1[]  = $this_figures[$thisKey][3];
            $y1_total += $this_figures[$thisKey][3];

            $y2[]  = $this_figures[$thisKey][1];
            $y2_total += $this_figures[$thisKey][1];
        };
    }; 
    
    if( !empty($mkStart) and !empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($mkStart);
        $dateStop = get_date_from_timestamp($mkStop);    
        $title .= " ( $l_block_graph_user_from $dateStart $l_block_graph_user_to $dateStop )";     
    };
         
    if( empty($mkStart) and empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($this_figures_KEY['0']);
        $dateStop = get_date_from_timestamp(end($this_figures_KEY));
        $title .= " ( $l_block_graph_user_from $dateStart $l_block_graph_user_to $dateStop )";
    };

    if( !empty($mkStart) and empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($mkStart);
        $title .= " ( $l_block_graph_user_since $dateStart )";
    };

    if( empty($mkStart) and !empty($mkStop) ) {
        $dateStop = get_date_from_timestamp($mkStop);
        $title .= " ( $l_block_graph_user_toEnd $dateStop )";
    };   


    $MyData = new pData();

    $MyData->addPoints($y1,$y1_title);
    $y1_colorscheme = array("R"=>15,"G"=>44,"B"=>52,"Alpha"=>80);
    $MyData->setPalette($y1_title,$y1_colorscheme);

    $MyData->addPoints($y2,$y2_title);
    $y2_colorscheme = array("R"=>184,"G"=>0,"B"=>40,"Alpha"=>80);
    $MyData->setPalette($y2_title,$y2_colorscheme);

    
    $MyData->addPoints($x,"Labels");
    $MyData->setSerieDescription("Labels","Month");
    $MyData->setAbscissa("Labels");

    /* Create the pChart object */
    $myPicture = new pImage(1000,300,$MyData);
    //$myPicture->drawGradientArea(0,0,1000,300,DIRECTION_VERTICAL,array("StartR"=>166,"StartG"=>202,"StartB"=>219,"EndR"=>0,"EndG"=>75,"EndB"=>123,"Alpha"=>100));  
    $myPicture->drawGradientArea(0,0,1000,300,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));  


    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,999,299,array("R"=>204,"G"=>204,"B"=>204));

    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(500,14,$title,array("R"=>247,"G"=>247,"B"=>247,"Align"=>TEXT_ALIGN_MIDDLEMIDDLE));

    /* Define the chart area */
    $myPicture->setGraphArea(58,27,980,228);

    /* Draw a rectangle */
    $myPicture->drawFilledRectangle(58,27,980,228,array("R"=>180,"G"=>180,"B"=>180,"Dash"=>TRUE,"DashR"=>250,"DashG"=>250,"DashB"=>250,"BorderR"=>150,"BorderG"=>150,"BorderB"=>150));

    /* Turn on shadow computing */
    $myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>20));

    /* Draw the scale */
    $myPicture->setFontProperties(array("FontSize"=>7,"R"=>47,"G"=>47,"B"=>47));
    $ScaleSettings = array("LabelRotation"=>45,"DrawArrows"=>TRUE,"ArrowSize"=>4,"DrawXLines"=>FALSE,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);
    $myPicture->drawScale($ScaleSettings);

    /* Write the chart legend */
    $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
    $myPicture->drawLegend(450,271,array("Style"=>LEGEND_NOBORDER));

    //number_format(, 0, '.', ' ')
    
    /* Write the 1st data series statistics */
    $Settings = array("R"=>15,"G"=>44,"B"=>52,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
    $myPicture->drawText(620,278,"Max : ".number_format(ceil($MyData->getMax($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(720,278,"Avg : ".number_format(ceil($MyData->getSerieAverage($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(820,278,"Total : ".number_format($y1_total, 0, '.', ' '),$Settings);

    /* Write the 2nd data series statistics */
    $Settings = array("R"=>184,"G"=>0,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
    $myPicture->drawText(620,291,"Max : ".number_format(ceil($MyData->getMax($y2_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(720,291,"Avg : ".number_format(ceil($MyData->getSerieAverage($y2_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(820,291,"Total : ".number_format($y2_total, 0, '.', ' '),$Settings);


    /* Write the Service*/
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawFromPNG(5,252,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");

    /* Draw the BarChart */
    $settings = array("Interleave"=>1,"Gradient"=>TRUE,"GradientMode"=>GRADIENT_EFFECT_CAN,"DisplayPos"=>LABEL_POS_INSIDE,"DisplayValues"=>FALSE,"DisplayR"=>255,"DisplayG"=>255,"DisplayB"=>255,"DisplayShadow"=>TRUE,"Surrounding"=>10);
    $myPicture->drawBarChart($settings);


    /* Render the picture (choose the best way) */
    $myPicture->render($img);

};

/*
$this_case : nbAtt (Number of attchment/mail), volAtt (Volume while attachment)
*/
function user_attachement_graphe_this(&$this_figures,&$this_figures_KEY,$this_user,$this_case,$mkStart,$mkStop) {

    Global $l_block_graph_user_nbAtt_title, $l_block_graph_user_volAtt_title,$l_block_graph_user_mimeOff_title, $l_block_graph_user_mimePict_title;
    Global $l_block_graph_user_mimeMmd_title, $l_block_graph_user_mimeComp_title;
    Global $l_block_graph_user_from, $l_block_graph_user_to, $l_block_graph_user_since, $l_block_graph_user_toEnd;   
    Global $path_to_data,$maxFullDateOnGraph ;

    $values = array() ;

    $setFull = "0" ;
    
    $path_to_img = $path_to_data.$_SESSION['domainName']."/img_user/";
    verif_existence_rep($path_to_img);


    /* pChart library inclusions */
    $path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;
    require_once $path_to_pChart."class/pData.class.php";
    require_once $path_to_pChart."class/pRadar.class.php";
    require_once $path_to_pChart."class/pDraw.class.php";
    require_once $path_to_pChart."class/pImage.class.php";

    $nbDate = count($this_figures_KEY);
    if($nbDate <= $maxFullDateOnGraph) {$setFull = "1"; };


    if($this_case == "nbAtt") {
         $values['0'] = 0 ;
        $values['1'] = 0 ;
        $values['2'] = 0 ;
        $values['3'] = 0 ;
        $values['4'] = 0 ;
        $values['5'] = 0 ;
        $values['6'] = 0 ;
 
        $img = $path_to_img.$this_user."_nbAtt_.png";
        $title = $l_block_graph_user_nbAtt_title." ".$this_user ;
       
        foreach ($this_figures_KEY as $thisKey) {
            $values['0']  += $this_figures[$thisKey]['4'];
            $values['1']  += $this_figures[$thisKey]['5'];
            $values['2']  += $this_figures[$thisKey]['6'];
            $values['3']  += $this_figures[$thisKey]['7'];
            $values['4']  += $this_figures[$thisKey]['8'];
            $values['5']  += $this_figures[$thisKey]['9'];
            $values['6']  += $this_figures[$thisKey]['10'];
        };

    };

    if($this_case == "volAtt") {
        $values['0'] = 0 ;
        $values['1'] = 0 ;
        $values['2'] = 0 ;
        $values['3'] = 0 ;
        $values['4'] = 0 ;
        $values['5'] = 0 ;
        $values['6'] = 0 ;
        $values['7'] = 0 ;
        $values['8'] = 0 ;

        $img = $path_to_img.$this_user."_volAtt_.png";
        $title = $l_block_graph_user_volAtt_title." ".$this_user; 
        
        foreach ($this_figures_KEY as $thisKey) {
            $values['0']  += $this_figures[$thisKey]['11'];
            $values['1']  += $this_figures[$thisKey]['12'];
            $values['2']  += $this_figures[$thisKey]['13'];
            $values['3']  += $this_figures[$thisKey]['14'];
            $values['4']  += $this_figures[$thisKey]['15'];
            $values['5']  += $this_figures[$thisKey]['16'];
            $values['6']  += $this_figures[$thisKey]['17'];
            $values['7']  += $this_figures[$thisKey]['18'];
            $values['8']  += $this_figures[$thisKey]['19'];
        };
    }; 
   
   
    if($this_case == "mimeOff") {
        $values['0']  = 0 ;
        $values['1']  = 0 ;
        $values['2']  = 0 ;
        $values['3']  = 0 ;
        $values['4']  = 0 ;
        $values['5']  = 0 ;
        $values['6']  = 0 ;
        $values['7']  = 0 ;
        $values['8']  = 0 ;
        $values['9']  = 0 ;
        $values['10'] = 0 ;
        $values['11'] = 0 ;

        $img = $path_to_img.$this_user."_mimeOff_.png";
        $title = $l_block_graph_user_mimeOff_title." ".$this_user; 
        
        foreach ($this_figures_KEY as $thisKey) {
            $values['0']  += $this_figures[$thisKey]['20'];
            $values['1']  += $this_figures[$thisKey]['21'];
            $values['2']  += $this_figures[$thisKey]['22'];
            $values['3']  += $this_figures[$thisKey]['23'];
            $values['4']  += $this_figures[$thisKey]['24'];
            $values['5']  += $this_figures[$thisKey]['25'];
            $values['6']  += $this_figures[$thisKey]['26'];
            $values['7']  += $this_figures[$thisKey]['27'];
            $values['8']  += $this_figures[$thisKey]['28'];
            $values['6']  += $this_figures[$thisKey]['29'];
            $values['7']  += $this_figures[$thisKey]['30'];
            $values['8']  += $this_figures[$thisKey]['31'];
        };
    }; 

 
    if($this_case == "mimePict") {
        $values['0'] = 0 ;
        $values['1'] = 0 ;
        $values['2'] = 0 ;
        $values['3'] = 0 ;
        $values['4'] = 0 ;
        $values['5'] = 0 ;

        $img = $path_to_img.$this_user."_mimePict_.png";
        $title = $l_block_graph_user_mimePict_title." ".$this_user; 
        
        foreach ($this_figures_KEY as $thisKey) {
            $values['0']  += $this_figures[$thisKey]['32'];
            $values['1']  += $this_figures[$thisKey]['33'];
            $values['2']  += $this_figures[$thisKey]['34'];
            $values['3']  += $this_figures[$thisKey]['35'];
            $values['4']  += $this_figures[$thisKey]['36'];
            $values['5']  += $this_figures[$thisKey]['37'];
        };
    }; 


    if($this_case == "mimeMmd") {
        $values['0'] = 0 ;
        $values['1'] = 0 ;
        $values['2'] = 0 ;
        $values['3'] = 0 ;
        $values['4'] = 0 ;
        $values['5'] = 0 ;
        $values['6'] = 0 ;

        $img = $path_to_img.$this_user."_mimeMmd_.png";
        $title = $l_block_graph_user_mimeMmd_title." ".$this_user; 
        
        foreach ($this_figures_KEY as $thisKey) {
            $values['0']  += $this_figures[$thisKey]['38'];
            $values['1']  += $this_figures[$thisKey]['39'];
            $values['2']  += $this_figures[$thisKey]['40'];
            $values['3']  += $this_figures[$thisKey]['41'];
            $values['4']  += $this_figures[$thisKey]['42'];
            $values['5']  += $this_figures[$thisKey]['43'];
            $values['6']  += $this_figures[$thisKey]['44'];
        };
    }; 


    if($this_case == "mimeComp") {
        $values['0'] = 0 ;
        $values['1'] = 0 ;
        $values['2'] = 0 ;
        $values['3'] = 0 ;
        $values['4'] = 0 ;
        $values['5'] = 0 ;

        $img = $path_to_img.$this_user."_mimeComp_.png";
        $title = $l_block_graph_user_mimeComp_title." ".$this_user; 
        
        foreach ($this_figures_KEY as $thisKey) {
            $values['0']  += $this_figures[$thisKey]['45'];
            $values['1']  += $this_figures[$thisKey]['46'];
            $values['2']  += $this_figures[$thisKey]['47'];
            $values['3']  += $this_figures[$thisKey]['48'];
            $values['4']  += $this_figures[$thisKey]['49'];
            $values['5']  += $this_figures[$thisKey]['50'];
        };
    }; 

    if( !empty($mkStart) and !empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($mkStart);
        $dateStop = get_date_from_timestamp($mkStop);    
        $title .= " ( $l_block_graph_user_from $dateStart $l_block_graph_user_to $dateStop )";     
    };
         
    if( empty($mkStart) and empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($this_figures_KEY['0']);
        $dateStop = get_date_from_timestamp(end($this_figures_KEY));
        $title .= " ( $l_block_graph_user_from $dateStart $l_block_graph_user_to $dateStop )";
    };

    if( !empty($mkStart) and empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($mkStart);
        $title .= " ( $l_block_graph_user_since $dateStart )";
    };

    if( empty($mkStart) and !empty($mkStop) ) {
        $dateStop = get_date_from_timestamp($mkStop);
        $title .= " ( $l_block_graph_user_toEnd $dateStop )";
    };  

    
    // Dataset definition   
    $MyData = new pData() ; 

    if($this_case == "nbAtt")    { $label = array("0","1","2","3","4","5","6+") ; };
    if($this_case == "volAtt")   { $label = array("<100K","<200K","<500K","<1M","<2M","<3M","<4M","<5M",">5M") ;};
    if($this_case == "mimePict") { $label = array("jpeg","tiff","png","svg","bmp","gif") ;};
    if($this_case == "mimeOff")  { $label = array("odt","ods","odp","doc","xls","ppt","txt","rtf","pdf","docx","xlsx","pptx") ;};
    if($this_case == "mimeMmd")  { $label = array("avi","wma","swf","mp3","mpeg","mov","vob") ;};
    if($this_case == "mimeComp") { $label = array("zip","bz","gz","7z","p7s","rar") ;}; 




    $MyData->AddPoints($label,"Label");
    $MyData->AddPoints($values,$this_user);  
    
    $MyData->SetAbscissa("Label");  

    /* Create the pChart object */
    $myPicture = new pImage(700,420,$MyData);
    
    $myPicture->drawGradientArea(0,0,700,420,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));
    $myPicture->drawGradientArea(0,0,700,20,DIRECTION_HORIZONTAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>10,"EndG"=>85,"EndB"=>133,"Alpha"=>100));
    
    $myPicture->drawLine(0,20,700,20,array("R"=>255,"G"=>255,"B"=>255));
    $RectangleSettings = array("R"=>180,"G"=>180,"B"=>180,"Alpha"=>100);
 
    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,699,419,array("R"=>0,"G"=>0,"B"=>0));
 
    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(10,15,$title,array("R"=>255,"G"=>255,"B"=>255));
 
    /* Set the default font properties */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>10,"R"=>80,"G"=>80,"B"=>80));
 
    /* Enable shadow computing */
    $myPicture->setShadow(TRUE,array("X"=>2,"Y"=>2,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>10));
 
    /* Create the pRadar object */
    $SplitChart = new pRadar();
 
    /* Draw a radar chart */
    $myPicture->setGraphArea(10,35,690,385);
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8,"R"=>5,"G"=>5,"B"=>5));
    $Options = array("DrawPoly"=>TRUE,"WriteValues"=>TRUE,"ValueFontSize"=>8,"Layout"=>RADAR_LAYOUT_STAR, "LabelPos"=>RADAR_LABELS_HORIZONTAL,"BackgroundGradient"=>array("StartR"=>255,"StartG"=>255,"StartB"=>255,"StartAlpha"=>100,"EndR"=>207,"EndG"=>227,"EndB"=>125,"EndAlpha"=>50));
    $SplitChart->drawRadar($myPicture,$MyData,$Options); 


    /* Write the Service*/
    $myPicture->drawFromPNG(530,364,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");


    /* Render the picture (choose the best way) */
    $myPicture->render($img);

};


/*
string mise_en_forme_chiffres_user($this_figures,$this_figures_KEY,$this_user,$mkStart,$mkStop)
*/
function mise_en_forme_chiffres_user(&$this_figures,&$this_figures_KEY,$this_user,$mkStart,$mkStop) {


    Global $l_block_graph_user_ingoing_title, $l_block_graph_user_outgoing_title, $l_block_graph_user_outgoingvol_title, $l_block_graph_user_ingoingvol_title;
    Global $l_block_graph_user_nbAtt_html_title, $l_block_graph_user_volAtt_html_title;
    Global $l_block_graph_user_from, $l_block_graph_user_to, $l_block_graph_user_since, $l_block_graph_user_toEnd;
    Global $l_block_graph_user_date,$l_block_graph_user_html_title,$l_block_graph_user_mimeOff_html_title,$l_block_graph_user_mimePict_html_title;
    Global $l_block_graph_user_mimeMmd_html_title,$l_block_graph_user_mimeCmp_html_title;
    Global $l_block_graph_user_mimeComp_html_title;

    if (!isset($mkStart)) $mkStart =''  ;
    if (!isset($mkStop))  $mkStop  =''  ;
    
    $titleDate = '' ;
    

    if( !empty($mkStart) and !empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($mkStart);
        $dateStop = get_date_from_timestamp($mkStop);
        $titleDate = " ( $l_block_graph_user_from $dateStart $l_block_graph_user_to $dateStop )";
    };

    if( !empty($mkStart) and empty($mkStop) ) {
        $dateStart = get_date_from_timestamp($mkStart);
        $titleDate= " ( $l_block_graph_user_since $dateStart )";
    };

    if( empty($mkStart) and !empty($mkStop) ) {
        $dateStop = get_date_from_timestamp($mkStop);
        $titleDate = " ( $l_block_graph_user_toEnd $dateStop )";
    };


    /* General Info*/
    $html  = '<table class="mytableDf" >';

    $html .= '    <tr>
                <td class="title" colspan="5"> '.$l_block_graph_user_html_title.' "'.$this_user.'" '.$titleDate.' </td>
                </tr>';

    $html .= '    <tr>
                    <td class="title"> '.$l_block_graph_user_date.' </td>
                    <td class="title"> '.$l_block_graph_user_ingoing_title.' </td>
                    <td class="title"> '.$l_block_graph_user_outgoing_title.' </td>
                    <td class="title"> '.$l_block_graph_user_ingoingvol_title.' (Ko)</td> 
                    <td class="title"> '.$l_block_graph_user_outgoingvol_title.' (Ko)</td>
                </tr>';
    $html .='<tr height="10px"></tr>';

    $html_general = '';
    $html_nbAtt   = '';
    $html_volAtt  = '';
    $htmlMimeOff  = '';
    $htmlMimePict = '';
    $htmlMimeMmd  = '';
    $htmlMimeComp = ''; 

    foreach ($this_figures_KEY as $thisKey) {
        $thisDate = get_date_from_timestamp($thisKey); 
             
        $html_general .= '<tr>
                    <td class="center">'.$thisDate.'</td>
                    <td class="center">'.$this_figures[$thisKey][2].'</td>
                    <td class="center">'.$this_figures[$thisKey][0].'</td>
                    <td class="center">'.$this_figures[$thisKey][3].'</td> 
                    <td class="center">'.$this_figures[$thisKey][1].'</td>
                  </tr>';
    
        $html_nbAtt .= '<tr>
                    <td class="center">'.$thisDate.'</td>
                    <td class="center">'.$this_figures[$thisKey][4].'</td>
                    <td class="center">'.$this_figures[$thisKey][5].'</td>
                    <td class="center">'.$this_figures[$thisKey][6].'</td> 
                    <td class="center">'.$this_figures[$thisKey][7].'</td>
                    <td class="center">'.$this_figures[$thisKey][8].'</td>
                    <td class="center">'.$this_figures[$thisKey][9].'</td> 
                    <td class="center">'.$this_figures[$thisKey][10].'</td>
                  </tr>';

        $html_volAtt .= '<tr>
                    <td class="center">'.$thisDate.'</td>
                    <td class="center">'.$this_figures[$thisKey][11].'</td>
                    <td class="center">'.$this_figures[$thisKey][12].'</td>
                    <td class="center">'.$this_figures[$thisKey][13].'</td> 
                    <td class="center">'.$this_figures[$thisKey][14].'</td>
                    <td class="center">'.$this_figures[$thisKey][15].'</td>
                    <td class="center">'.$this_figures[$thisKey][16].'</td> 
                    <td class="center">'.$this_figures[$thisKey][17].'</td>
                    <td class="center">'.$this_figures[$thisKey][18].'</td> 
                    <td class="center">'.$this_figures[$thisKey][19].'</td>
                  </tr>';



            $htmlMimeOff .= '<tr>
                    <td class="center">'.$thisDate.'</td>
                    <td class="center">'.$this_figures[$thisKey][20].'</td>
                    <td class="center">'.$this_figures[$thisKey][21].'</td>
                    <td class="center">'.$this_figures[$thisKey][22].'</td>
                    <td class="center">'.$this_figures[$thisKey][23].'</td>
                    <td class="center">'.$this_figures[$thisKey][24].'</td>
                    <td class="center">'.$this_figures[$thisKey][25].'</td>
                    <td class="center">'.$this_figures[$thisKey][26].'</td>
                    <td class="center">'.$this_figures[$thisKey][27].'</td>
                    <td class="center">'.$this_figures[$thisKey][28].'</td>
                    <td class="center">'.$this_figures[$thisKey][29].'</td>
                    <td class="center">'.$this_figures[$thisKey][30].'</td>
                    <td class="center">'.$this_figures[$thisKey][31].'</td>
                </tr>';
            
            $htmlMimePict .= '<tr>
                    <td class="center">'.$thisDate.'</td>
                    <td class="center">'.$this_figures[$thisKey][32].'</td>
                    <td class="center">'.$this_figures[$thisKey][33].'</td>
                    <td class="center">'.$this_figures[$thisKey][34].'</td>
                    <td class="center">'.$this_figures[$thisKey][35].'</td>
                    <td class="center">'.$this_figures[$thisKey][36].'</td>
                    <td class="center">'.$this_figures[$thisKey][37].'</td>
                    </tr>';

             $htmlMimeMmd .= '<tr>
                    <td class="center">'.$thisDate.'</td>
                    <td class="center">'.$this_figures[$thisKey][38].'</td>
                    <td class="center">'.$this_figures[$thisKey][39].'</td>
                    <td class="center">'.$this_figures[$thisKey][40].'</td>
                    <td class="center">'.$this_figures[$thisKey][41].'</td>
                    <td class="center">'.$this_figures[$thisKey][42].'</td>
                    <td class="center">'.$this_figures[$thisKey][43].'</td>
                    <td class="center">'.$this_figures[$thisKey][44].'</td>
                </tr>';

            $htmlMimeComp .= '<tr>
                    <td class="center">'.$thisDate.'</td>
                    <td class="center">'.$this_figures[$thisKey][45].'</td>
                    <td class="center">'.$this_figures[$thisKey][46].'</td>
                    <td class="center">'.$this_figures[$thisKey][47].'</td>
                    <td class="center">'.$this_figures[$thisKey][48].'</td>
                    <td class="center">'.$this_figures[$thisKey][49].'</td>
                    <td class="center">'.$this_figures[$thisKey][50].'</td>
                </tr>';
    };

    $html .= '</table>';
    $html .= '<br>';


    /* Figures about attachment/mail */
    $html  .= '<table class="mytableDf" >';

    $html .= '<tr>
                <td class="title" colspan="8"> '.$l_block_graph_user_nbAtt_html_title.' "'.$this_user.'" '.$titleDate.' </td>
            </tr>';

    $html .= '<tr>
                <td class="title"> '.$l_block_graph_user_date.' </td>
                <td class="title"> 0 </td>
                <td class="title"> 1 </td>
                <td class="title"> 2 </td> 
                <td class="title"> 3 </td>
                <td class="title"> 4 </td>
                <td class="title"> 5 </td>
                <td class="title"> 6+ </td>
            </tr>';
    $html .= $html_nbAtt ;
    $html .= '</table>';
    $html .= '<br>';


    /* Figures about attachment/mail */
    $html  .= '<table class="mytableDf" >';

    $html .= '<tr>
                <td class="title" colspan="10"> '.$l_block_graph_user_volAtt_html_title.' "'.$this_user.'" '.$titleDate.' </td>
            </tr>';
    $html .= '<tr>
                <td class="title"> '.$l_block_graph_user_date.' </td>
                <td class="title"> < 100Ko </td>
                <td class="title"> < 200Ko </td>
                <td class="title"> < 500Ko </td> 
                <td class="title"> < 1Mo </td>
                <td class="title"> < 2Mo</td>
                <td class="title"> < 3Mo </td>
                <td class="title"> < 4Mo</td>
                <td class="title"> < 5Mo </td>
                <td class="title"> > 5Mo</td>
            </tr>';
    $html .= $html_volAtt;

    $html .= '</table>';
    $html .= '<br>';


 
    /* Figures about office applications attachment */
    $html  .= '<table class="mytableDf" >';

    $html .= '<tr>
                <td class="title" colspan="13"> '.$l_block_graph_user_mimeOff_html_title.' "'.$this_user.'" '.$titleDate.' </td>
            </tr>';
            
    $html .= '<tr>
                <td class="title"> '.$l_block_graph_user_date.' </td>
                <td class="title"> odt </td>
                <td class="title"> ods </td>
                <td class="title"> odp </td>
                <td class="title"> doc </td>
                <td class="title"> xls </td>
                <td class="title"> ppt </td>
                <td class="title"> txt </td>
                <td class="title"> rtf </td>
                <td class="title"> pdf </td>
                <td class="title"> docx </td>
                <td class="title"> xlsx </td>
                <td class="title"> pptx </td>
            </tr>';

    $html .= $htmlMimeOff ;    
    $html .= '</table>';
    $html .= '<br>';


    /* Figures about  pictures attachments */
    $html  .= '<table class="mytableDf" >';

    $html .= '<tr>
                <td class="title" colspan="10"> '.$l_block_graph_user_mimePict_html_title.' "'.$this_user.'" '.$titleDate.' </td>    
            </tr>';

    $html .= '<tr>
                <td class="title"> '.$l_block_graph_user_date.' </td>
                <td class="title"> jpeg </td>
                <td class="title"> tiff </td>
                <td class="title"> png </td>
                <td class="title"> svg </td>
                <td class="title"> bmp </td>
                <td class="title"> gif </td>
            </tr>';
    
    $html .= $htmlMimePict ;
    $html .= '</table>';
    $html .= '<br>';


    /* Figures about  multimedia attachments */
    $html  .= '<table class="mytableDf" >';

    $html .= '<tr>
                <td class="title" colspan="10"> '.$l_block_graph_user_mimeMmd_html_title.' "'.$this_user.'" '.$titleDate.' </td>
            </tr>';
            
    $html .= '<tr>
                <td class="title"> '.$l_block_graph_user_date.' </td>
                <td class="title"> avi </td>
                <td class="title"> wma </td>
                <td class="title"> swf </td>
                <td class="title"> mp3 </td>
                <td class="title"> mpeg </td>
                <td class="title"> mov </td>
                <td class="title"> vob </td>
            </tr>';
    
    $html .= $htmlMimeMmd ;
    $html .= '</table>';
    $html .= '<br>';

    /* Figures about  compression type attachments */
    $html  .= '<table class="mytableDf" >';

    $html .= '<tr>
                <td class="title" colspan="10"> '.$l_block_graph_user_mimeComp_html_title.' "'.$this_user.'" '.$titleDate.' </td>
            </tr>';
            
    $html .= '<tr>
                <td class="title"> '.$l_block_graph_user_date.' </td>
                <td class="title"> zip </td>
                <td class="title"> bz </td>
                <td class="title"> gz </td>
                <td class="title"> 7z </td>
                <td class="title"> p7s </td>
                <td class="title"> rar </td>
            </tr>';
    
    $html .= $htmlMimeComp ;
    $html .= '</table>';
    $html .= '<br>';

    return $html;
};

/*
string mise_en_page_stat_user(string($this_user),date($dateStart),date($dateStop))

*/

function mise_en_page_stat_user($bmUser,$dateStart,$dateStop,$exportToPdf,$viewData) {

    Global $l_block_submit, $l_userstat_start_day, $l_userstat_stop_day,$l_block_graph_user_pdf_download,$l_block_graph_user_noData, $l_userstat_viewData ;
    Global $l_userquota_evolution ;

$thisUserQuotaOverviewLink = "
    <form method='POST'  action='quotaUserOverview.php' onsubmit=\"popupForm(this)\">
         <input type='submit' value='$l_userquota_evolution'>
        <input type='hidden' name='user' value='$bmUser'/>
    </form> " ;

    $imgDir = "./mailstat/".$_SESSION['domainName']."/img_user/";
   
    $this_figures = array() ;
    $this_figures_KEY = array() ;
   
    $oneYear = 1 ; 

    if (!isset($mkStart)) $mkStart =''  ;
    if (!isset($mkStop))  $mkStop  =''  ;
  
    $titleDate = '' ;

    if(!empty($dateStart) or !empty($dateStop) ) {
        $oneYear = 0 ;    
    };

    
    /*Get figures from user stat file*/
    $this_figures = get_figures_from_user($bmUser,$oneYear) ;

    //Do job only if some data
    if(!empty($this_figures)) {    
        $this_figures_KEY = array_keys($this_figures) ;

        //Delete all values ante $dateStart
        if(!empty($dateStart)) {
            $mkStart = mktime_this_date($dateStart) ;
            $this_figures_KEY = reduce_this_array($this_figures_KEY,$mkStart,$sens="A");
        };
        
        //Delete all values post $dateStop
        if(!empty($dateStop)) {
            $mkStop = mktime_this_date($dateStop) ;
            $this_figures_KEY = reduce_this_array($this_figures_KEY,$mkStop,$sens="P");
        };  



        user_general_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="N",$mkStart,$mkStop);
        @user_general_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="V",$mkStart,$mkStop);
        @user_attachement_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="nbAtt",$mkStart,$mkStop);
        @user_attachement_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="volAtt",$mkStart,$mkStop);
        @user_attachement_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="mimeOff",$mkStart,$mkStop);
        @user_attachement_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="mimePict",$mkStart,$mkStop);
        @user_attachement_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="mimeMmd",$mkStart,$mkStop);
        @user_attachement_graphe_this($this_figures,$this_figures_KEY,$bmUser,$this_case="mimeComp",$mkStart,$mkStop);

        
        if($viewData == 1) {  
            $figure_html_tab = mise_en_forme_chiffres_user($this_figures,$this_figures_KEY,$bmUser,$mkStart,$mkStop);
        };
   
        if($exportToPdf == 1) {
            exportToPDF($this_figures,$this_figures_KEY,$bmUser);
        };


        $this_page = "
        <br>
        <div id='ombreeH12'>
        <h1 id=\"h12\">
        <form method='POST' action='?' name='userfrm' id='form2'>
        <table class='myUserTable'>
        <tr>
            <td>
                $l_userstat_start_day : 
            </td>
            <td>
                <input type='text' name=\"dateStart\" style='width:150px;'/>
                <script language='JavaScript'>
                new tcal ({
                // form name
                'formname': 'userfrm',
                // input name
                'controlname': 'dateStart'
                });
            </script>
            </td>

            <td> &nbsp;
            </td>

            <td>
                $l_userstat_stop_day : 
            </td>
            <td>
                <input type='text' name=\"dateStop\" style='width:150px;'/>
                <script language='JavaScript'>
                new tcal ({
                // form name
                'formname': 'userfrm',
                // input name
                'controlname': 'dateStop'
                });
            </script>
            </td>       

            <td>
            Export PDF <input name='exportToPdf'  type='checkbox' value='1'>
            </td>

            <td>
                $l_userstat_viewData <input name='viewData'  type='checkbox' value='1'>
            </td>
            <td>
                <input type='hidden' name='action' value='userstat'>
                <input type='hidden' name='item' value='User'>
                <input type='hidden' name='userbm' value='$bmUser'>
            </td>
            <td>
                <div id='loading2' style='display:none;'>&nbsp;&nbsp;&nbsp;<img src='./images/loader.gif' alt='' /></div>
                <input id='submit2' type='submit' name='Submit' value='$l_block_submit'>
             </td>
        </tr>
        </table>
        </form>
        </h1>
        <script type='text/javascript'>
            (function (e) {
                e.getElementById('form2').onsubmit = function () {
                    e.getElementById('submit2').style.display = 'none';
                    e.getElementById('loading2').style.display = 'block';
                };
            }(document));
         </script>



        </div>";


        if($exportToPdf == 1) {
            // PDF file name
            $filename = $imgDir.$bmUser.".pdf";
            $this_page.="
            <div><h1 class=''></h1></div>
            <div class=''> <img src='./images/application-pdf.png'> <a href='$filename' border='0' target='_blank'>$l_block_graph_user_pdf_download</a></div>
            <div>";
        };


        $this_page.="
        <br/>
        <div id='ombreeH12'> <h1 id=\"h12\"> $thisUserQuotaOverviewLink</h1></div>


        <br/>
        <div><h1 class=''></h1></div>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_N_.png'></div>
        <br>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_V_.png'></div>    ";
            
        $this_page.="
        <div><h1 class=''></h1></div>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_nbAtt_.png'></div>
        <br>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_volAtt_.png'></div>";

        $this_page.="
        <br>
        <div><h1 class=''></h1></div>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_mimeOff_.png'></div>
        <br>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_mimePict_.png'></div>
        <br>
        <div><h1 class=''></h1></div>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_mimeMmd_.png'></div>
        <br>
        <div class=''><img class='shadow' src='".$imgDir.$bmUser."_mimeComp_.png'></div>";


        if($viewData == 1) {
            $this_page.="
            <br>
            <div><h1 class=''></h1></div>
            <br>
            $figure_html_tab";
        };

    } else {
        $this_page  = "<br>";
        $this_page .= "$l_block_graph_user_noData \"$bmUser\"";
        $this_page .= "";
    };

    return $this_page ;

};



/*
srting exportToPDF($html,$this_figures_KEY,$this_user)
*/
function exportToPDF(&$this_figures,&$this_figures_KEY,$this_user) {

    Global $lang,$path_to_data ;
    
    require_once('/usr/share/bm-stats/scripts/PHP/tcpdf/config/lang/eng.php');
    require_once('/usr/share/bm-stats/scripts/PHP/tcpdf/tcpdf.php');
    require("/usr/share/bm-stats/www/inc_lang/inc_lang_".$lang.".php");

    
    $filename = $path_to_data.$_SESSION['domainName']."/img_user/".$this_user.".pdf";

    copyToTMP($this_user,$this_case="N");
    copyToTMP($this_user,$this_case="V");
    copyToTMP($this_user,$this_case="nbAtt");
    copyToTMP($this_user,$this_case="volAtt");
    copyToTMP($this_user,$this_case="mimeOff");
    copyToTMP($this_user,$this_case="mimePict");
    copyToTMP($this_user,$this_case="mimeMmd");
    copyToTMP($this_user,$this_case="mimeComp");

    // create new PDF document
    $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

    // set document information
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->SetAuthor('BM Stats');
    $pdf->SetTitle($pdf_userreport_SetTitle);
    $pdf->SetSubject($pdf_userreport_SetSubject);
    $pdf->SetKeywords($pdf_userreport_SetKeywords);


    // set default header data
    $pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, $pdf_userreport_SetHeaderDataTitle.' : '.$this_user, PDF_HEADER_STRING);

    // set header and footer fonts
    $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
    $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

    // set default monospaced font
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

    //set margins
    $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
    $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
    $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

    //set auto page breaks
    $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

    //set some language-dependent strings
    $pdf->setLanguageArray($l);

    // set font
    $pdf->SetFont('dejavusans', '', 10);


    /*
    1rst Page 
    */

    $pdf->AddPage();
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $html ='
    <table width="100%" cellpadding="0" cellspacing="0" border="0" >
      <tr><td height="200"></td></tr>
     <tr>
            <td valign="middle" align="center">
            <img src="./images/bmStats-pdf.png" width="375" height="300">
              </td>
     </tr>
    </table>';
    $pdf->writeHTML($html, true, false, true, false, '');





    /*
    1rst Chapter : Graph NB of messages
    */
    $title = $pdf_userreport_NB_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('1) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
        <br><br>
        <b><font size="12px">1) <u>'.$title.'</font></u></b> :<br>
        <br>';

    
    $html .='
        <br>
            <img src="./tmp/'.$this_user.'_N_.png" width="900" height="270"><br>
        <br>';


    $pdf->writeHTML($html, true, false, true, false, '');

    

    /*
    2nd Chapter : Graph VOL of messages
    */
    $title = $pdf_userreport_VOL_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    
    $pdf->Bookmark('2) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">2) <u>'.$title.'</font></u></b> :<br>
    <br>';

    $html .='
    <br>
    <img src="./tmp/'.$this_user.'_V_.png" width="900" height="270"><br>
    <br>';

    $pdf->writeHTML($html, true, false, true, false, '');


    /*
    3rd Chapter : Graph nbAtt
    */
    $title = $pdf_userreport_NBATT_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('3) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">3) <u>'.$title.'</font></u></b> :<br>
    <br>';

    $html .='
    <br>
    <img src="./tmp/'.$this_user.'_nbAtt_.png" width="630" height="378"><br>
    <br>';

    $pdf->writeHTML($html, true, false, true, false, '');


    /*
    4th Chapter : Graph volAtt
    */
    $title = $pdf_userreport_VOLATT_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('4) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">4) <u>'.$title.'</font></u></b> :<br>
    <br>';

    $html .='
    <br>
    <img src="./tmp/'.$this_user.'_volAtt_.png" width="630" height="378"><br>
    <br>';

    $pdf->writeHTML($html, true, false, true, false, '');


    /*
    5th Chapter : Graph mimeOff
    */

    $title = $pdf_userreport_MIMEOFF_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('5) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">5) <u>'.$title.'</font></u></b> :<br>
    <br>';

    $html .='
    <br>
    <img src="./tmp/'.$this_user.'_mimeOff_.png" width="630" height="378"><br>
    <br>';

    $pdf->writeHTML($html, true, false, true, false, '');



    /*
    6th Chapter : mimePict    
    */

    $title = $pdf_userreport_MIMEPICT_title ;    
    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('6) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">6) <u>'.$title.'</font></u></b> :<br>
    <br>';

    $html .='
    <br>
    <img src="./tmp/'.$this_user.'_mimePict_.png" width="630" height="378"><br>
    <br>';

    $pdf->writeHTML($html, true, false, true, false, '');


    /*
    7th Chapter : mimeMmd   
    */

    $title = $pdf_userreport_MIMEMMD_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('7) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">7) <u>'.$title.'</font></u></b> :<br>
    <br>';

    $html .='
    <br>
    <img src="./tmp/'.$this_user.'_mimeMmd_.png" width="630" height="378"><br>
    <br>';

    $pdf->writeHTML($html, true, false, true, false, '');



    /*
    8th Chapter : mimeComp  
    */

    $title = $pdf_userreport_MIMECOMP_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('8) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">8) <u>'.$title.'</font></u></b> :<br>
    <br>';

    $html .='
    <br>
    <img src="./tmp/'.$this_user.'_mimeComp_.png" width="630" height="378"><br>
    <br>';

    $pdf->writeHTML($html, true, false, true, false, '');

    
    
    
     /*
    9th Chapter : Figures 
    */

    /* Headline */
    $firstday = get_date_from_timestamp($this_figures_KEY['0']); 
    $lastday  = get_date_from_timestamp(end($this_figures_KEY));
    $title = $pdf_userreport_FIG_title ;
    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('9) '.$title.'', 0, 0, '', '', array(128,0,0));


    $html_general = '';
    $html_nbAtt   = '';
    $html_volAtt  = '';
    $htmlMimeOff  = '';
    $htmlMimePict = '';
    $htmlMimeMmd  = '';
    $htmlMimeComp = ''; 

    foreach ($this_figures_KEY as $thisKey) {
        $thisDate = get_date_from_timestamp($thisKey) ;

    $html_general .= '<tr>
        <td align="center"><font size="8px">'.$thisDate.'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][2].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][0].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][3].'</font></td> 
        <td align="center"><font size="8px">'.$this_figures[$thisKey][1].'</font></td>
    </tr>';

    $html_nbAtt .= ' <tr>
        <td align="center"><font size="8px">'.$thisDate.'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][4].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][5].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][6].'</font></td> 
        <td align="center"><font size="8px">'.$this_figures[$thisKey][7].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][8].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][9].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][10].'</font></td> 
    </tr>';

    $html_volAtt .= '<tr>
        <td align="center"><font size="8px">'.$thisDate.'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][11].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][12].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][13].'</font></td> 
        <td align="center"><font size="8px">'.$this_figures[$thisKey][14].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][15].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][16].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][17].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][18].'</font></td>
        <td align="center"><font size="8px">'.$this_figures[$thisKey][19].'</font></td>
    </tr>';


    $htmlMimeOff .= '<tr>
        <td class="center">'.$thisDate.'</td>
        <td class="center">'.$this_figures[$thisKey][20].'</td>
        <td class="center">'.$this_figures[$thisKey][21].'</td>
        <td class="center">'.$this_figures[$thisKey][22].'</td>
        <td class="center">'.$this_figures[$thisKey][23].'</td>
        <td class="center">'.$this_figures[$thisKey][24].'</td>
        <td class="center">'.$this_figures[$thisKey][25].'</td>
        <td class="center">'.$this_figures[$thisKey][26].'</td>
        <td class="center">'.$this_figures[$thisKey][27].'</td>
        <td class="center">'.$this_figures[$thisKey][28].'</td>
        <td class="center">'.$this_figures[$thisKey][29].'</td>
        <td class="center">'.$this_figures[$thisKey][30].'</td>
        <td class="center">'.$this_figures[$thisKey][31].'</td>
    </tr>';

    $htmlMimePict .= '<tr>
        <td class="center">'.$thisDate.'</td>
        <td class="center">'.$this_figures[$thisKey][32].'</td>
        <td class="center">'.$this_figures[$thisKey][33].'</td>
        <td class="center">'.$this_figures[$thisKey][34].'</td>
        <td class="center">'.$this_figures[$thisKey][35].'</td>
        <td class="center">'.$this_figures[$thisKey][36].'</td>
        <td class="center">'.$this_figures[$thisKey][37].'</td>
    </tr>';

    $htmlMimeMmd .= '<tr>
        <td class="center">'.$thisDate.'</td>
        <td class="center">'.$this_figures[$thisKey][38].'</td>
        <td class="center">'.$this_figures[$thisKey][39].'</td>
        <td class="center">'.$this_figures[$thisKey][40].'</td>
        <td class="center">'.$this_figures[$thisKey][41].'</td>
        <td class="center">'.$this_figures[$thisKey][42].'</td>
        <td class="center">'.$this_figures[$thisKey][43].'</td>
        <td class="center">'.$this_figures[$thisKey][44].'</td>
    </tr>';

    $htmlMimeComp .= '<tr>
        <td class="center">'.$thisDate.'</td>
        <td class="center">'.$this_figures[$thisKey][45].'</td>
        <td class="center">'.$this_figures[$thisKey][46].'</td>
        <td class="center">'.$this_figures[$thisKey][47].'</td>
        <td class="center">'.$this_figures[$thisKey][48].'</td>
        <td class="center">'.$this_figures[$thisKey][49].'</td>
        <td class="center">'.$this_figures[$thisKey][50].'</td>
    </tr>';

               
    };

    $html = '
        <b><font size="12px">9) <u>'.$title.'</font></u></b> :<br>
        <br>';
    $pdf->writeHTML($html, true, false, true, false, ''); 

    /* General Fig. */
    $title = $pdf_userreport_FIGen_title ;
    $pdf->Bookmark('9-1) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html = '
        <b><font size="12px">9-1) '.$title.'</font></b> :<br>
        <br>';
    $html .= '<table border="1" cellspacing="0" >';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center" > '.$pdf_userreport_FIGen_title.' "'.$this_user.'" ('.$l_block_graph_user_from.' '.$firstday.' '.$l_block_graph_user_to.' '.$lastday.') </td>
        </tr>
    </table>
    <br>';

    $html .='<table border="1" cellspacing="0" align="center">';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_date.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_ingoing_title.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_outgoing_title.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_ingoingvol_title.' (Ko)</font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_outgoingvol_title.' (Ko)</font> </td>
        </tr>';

    $html .= $html_general ; 

    $html .= '</table>';
    $pdf->writeHTML($html, true, false, true, false, '');


    /* nbAtt Fig */
    $title = $pdf_userreport_FIGnbAtt_title ;
    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('9-2) '.$title.'', 1, 0, '', '', array(128,0,0));

    $html = '
        <b><font size="12px">9-2) '.$title.'</font></b> :<br>
        <br>';
    $html .= '<table border="1" cellspacing="0" >';

    $html .= '<tr>
            <td bgcolor="#d2d2d2" align="center" > '.$pdf_userreport_FIGnbAtt_title.' "'.$this_user.'" ('.$l_block_graph_user_from.' '.$firstday.' '.$l_block_graph_user_to.' '.$lastday.') </td>
        </tr>
        </table>
        <br>';

    $html .='<table border="1" cellspacing="0" align="center">';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_date.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 0 </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 1 </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 2 </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 3 </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 4 </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 5 </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 6+ </font> </td> 
    </tr>';

    $html .= $html_nbAtt ;
    $html .= '</table>';
    $pdf->writeHTML($html, true, false, true, false, '');


    /* Fig volAtt */
    $title = $pdf_userreport_FIGvolAtt_title ;

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('9-3) '.$title.'', 1, 0, '', '', array(128,0,0));


    $html = '
        <b><font size="12px">9-3) '.$title.'</font></b> :<br>
        <br>';
    $html .= '<table border="1" cellspacing="0" >';

    $html .= '<tr>
            <td bgcolor="#d2d2d2" align="center" > '.$pdf_userreport_FIGvolAtt_title.' "'.$this_user.'" ('.$l_block_graph_user_from.' '.$firstday.' '.$l_block_graph_user_to.' '.$lastday.') </td>
        </tr>
        </table>
        <br>';

    $html .='<table border="1" cellspacing="0" align="center">';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_date.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 100Ko </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 200Ko </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 500Ko </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 1Mo </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 2Mo </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 3Mo </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 4Mo </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &lt; 5Mo </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> &gt; 5Mo </font> </td>
    </tr>';

    $html .= $html_volAtt ;
    $html .= '</table>';
    $pdf->writeHTML($html, true, false, true, false, '');


      
    /* mime Fig */
  

    /* mimeOff Fig */
    $title = $pdf_userreport_FIGmimeOff_title ;
    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('9-4) '.$title.'', 1, 0, '', '', array(128,0,0));

    $html = '
        <b><font size="12px">9-4) '.$title.'</font></b> :<br>
        <br>';
    $html .= '<table border="1" cellspacing="0" >';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center" > '.$pdf_userreport_FIGmimeOff_title.' "'.$this_user.'" ('.$l_block_graph_user_from.' '.$firstday.' '.$l_block_graph_user_to.' '.$lastday.') </td>
    </tr>
    </table>
    <br>';

    $html .='<table border="1" cellspacing="0" align="center">';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_date.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> odt </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> ods </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> odp </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> doc </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> xls </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> ppt </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> txt </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> rtf </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> pdf </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> docx </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> xlsx </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> pptx </font> </td>
    </tr>';  
    
    $html .=  $htmlMimeOff;
    $html .= '</table>';
    $pdf->writeHTML($html, true, false, true, false, '');



    /* mimePict Fig */
    $title = $pdf_userreport_FIGmimePict_title ;
    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('9-5) '.$title.'', 1, 0, '', '', array(128,0,0));

    $html = '
        <b><font size="12px">9-5) '.$title.'</font></b> :<br>
        <br>';
    $html .= '<table border="1" cellspacing="0" >';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center" > '.$pdf_userreport_FIGmimePict_title.' "'.$this_user.'" ('.$l_block_graph_user_from.' '.$firstday.' '.$l_block_graph_user_to.' '.$lastday.') </td>
         </tr>
         </table>
         <br>
         ';

    $html .='<table border="1" cellspacing="0" align="center">';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_date.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> jpeg </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> tiff </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> png </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> svg </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> bmp </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> gif </font> </td>
    </tr>';  
    
    $html .=  $htmlMimePict;
    $html .= '</table>';
    $pdf->writeHTML($html, true, false, true, false, '');


    /* mimeMmd Fig */
    $title = $pdf_userreport_FIGmimeMmd_title ;
    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('9-6) '.$title.'', 1, 0, '', '', array(128,0,0));

    $html = '
        <b><font size="12px">9-6) '.$title.'</font></b> :<br>
    <br>';
    
    $html .= '<table border="1" cellspacing="0" >';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center" > '.$pdf_userreport_FIGmimeMmd_title.' "'.$this_user.'" ('.$l_block_graph_user_from.' '.$firstday.' '.$l_block_graph_user_to.' '.$lastday.') </td>
    </tr>
    </table>
    <br>';

    $html .='<table border="1" cellspacing="0" align="center">';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_date.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> avi </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> wma </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> swf </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> mp3 </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> mpeg </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> mov </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> vob </font> </td>
    </tr>';  
    
    $html .=  $htmlMimeMmd;
    $html .= '</table>';
    $pdf->writeHTML($html, true, false, true, false, '');



    /* mimeComp Fig */
    $title = $pdf_userreport_FIGmimeComp_title ;
    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('9-7) '.$title.'', 1, 0, '', '', array(128,0,0));

    $html = '
        <b><font size="12px">9-7) '.$title.'</font></b> :<br>
    <br>';
    $html .= '<table border="1" cellspacing="0" >';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center" > '.$pdf_userreport_FIGmimeComp_title.' "'.$this_user.'" ('.$l_block_graph_user_from.' '.$firstday.' '.$l_block_graph_user_to.' '.$lastday.') </td>
    </tr>
    </table>
    <br>';

    $html .='<table border="1" cellspacing="0" align="center">';

    $html .= '<tr>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px">'.$l_block_graph_user_date.'</font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> zip </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> bz </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> gz </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> 7z </font> </td>
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> p7s </font> </td> 
        <td bgcolor="#d2d2d2" align="center"> <font size="8px"> rar </font> </td>
    </tr>';  
    
    $html .=  $htmlMimeComp;
    $html .= '</table>';
    $pdf->writeHTML($html, true, false, true, false, '');




// add a new page for TOC
    $pdf->addTOCPage('P','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    // write the TOC title
    $pdf->SetFont('times', 'B', 16);
    $this_title = $pdf_userreport_TOCTitle;
    $pdf->MultiCell(0, 0, $this_title, 0, 'C', 0, 1, '', '', true, 0);
    $pdf->Ln();
    $pdf->SetFont('dejavusans', '', 12);
    $pdf->addTOC(1, 'courier', '.', 'INDEX', 'B', array(128,0,0));
    $pdf->endTOCPage();



    // switch Page Nr1 and Page Nr2
    $pdf->movePage(2, 1);



    //Close and output PDF document
    $pdf->Output($filename, 'F');

    delInTMP($this_user,$this_case="N");
    delInTMP($this_user,$this_case="V");
    delInTMP($this_user,$this_case="nbAtt");
    delInTMP($this_user,$this_case="volAtt");
    delInTMP($this_user,$this_case="mimeOff");
    delInTMP($this_user,$this_case="mimePict");
    delInTMP($this_user,$this_case="mimeMmd");
    delInTMP($this_user,$this_case="mimeComp");
}



?>
